#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <search.h>
#include <time.h>
#include <math.h>
#include "ge.h"

#define NUM 12
#define PNUM 11

using namespace std;

long max(long x, long y)
{
	if (x>y)
		return x;
	else return y;
}

long min(long x, long y)
{
	if (x<y)
		return x;
	else return y;
}

int main(int argv, char * argc[])
{
	FILE *fpc,*fpc2,*fpc3,*fpc4,*fpc5,*fpc6,*fp;
	char fnc[1024],fnc2[1024],fnc3[1024],fnc4[1024],temp[1024],fnc5[1024],fnc6[1024];
	long s[NUM][PNUM];
	long i,j,l,m,N,K;
	int *mark,rd,*v1,*v2;
	int expid,**data;
	long ins,dlt,upd,r1,r2,j1,j2;
	double d[NUM];
	
	srand((unsigned)time(NULL));

	if (argv!=3)
	{
		printf("parameter error!\n");
		return 0;
	}
	
	expid=atoi(argc[1]);
	sprintf(fnc,"./%s/config",argc[2]); 
	sprintf(fnc2,"./%s/existing_table.txt",argc[2]);
	sprintf(fnc3,"./%s/new_table.txt",argc[2]);
	sprintf(fnc4,"./%s/customer_table.txt",argc[2]);
//	sprintf(fnc5,"./%s/update_table.txt",argc[2]);    
	sprintf(fnc5,"./%s/insert_table.txt",argc[2]);  
  sprintf(fnc6,"./%s/delete_table.txt",argc[2]); 
	

	if((fp=fopen("upsetting.txt","r"))==NULL)
	{
		printf("Cannot open file!\n");
		return (0);
	}	
	
	for(i=0;i<NUM;i++)
	{
		for(j=0;j<PNUM;j++)
		{
			fscanf(fp,"%s",temp);
			if(j!=5)
				s[i][j]=atoi(temp);
			else 
				d[i]=atof(temp);
		}
	}
	
	fclose(fp);
	
	if((fpc=fopen(fnc,"w+"))==NULL)
	{
		printf("Cannot open file %s!\n",fnc);
		return (0);
	}	
	
	for(j=3;j<PNUM;j++)
	{
		if(j!=8)
		{
		if(j!=5)
			fprintf(fpc,"%d ",s[expid-1][j]);
		else 
			fprintf(fpc,"%f ",d[expid-1]);
		}
	}
	fprintf(fpc,"\n");
	fclose(fpc);
	
	
	mark=(int *)malloc(sizeof(int)*s[expid-1][0]);
	v1=(int *)malloc(sizeof(int)*s[expid-1][2]);
	v2=(int *)malloc(sizeof(int)*s[expid-1][2]);
	for(i=0;i<s[expid-1][0];i++)
		mark[i]=0;
	
	if((fpc2=fopen(fnc2,"w+"))==NULL)
	{
		printf("Cannot open file %s!\n",fnc2);
		return (0);
	}	
	
		
	if((fpc3=fopen(fnc3,"w+"))==NULL)
	{
		printf("Cannot open file %s!\n",fnc3);
		return (0);
	}
	
	//generate existing_table.txt		
	//generate new_table.txt	
	
	ge(s[expid-1][0],s[expid-1][1],s[expid-1][2],fpc3,fpc2);
	
	fclose(fpc2);
	
	fclose(fpc3);
	
/*	if((fpc4=fopen(fnc4,"w+"))==NULL)
	{
		printf("Cannot open file %s!\n",fnc4);
		return (0);
	}
*/	
//	printf("test\n");
	
	//generate customer_table.txt
//	fprintf(fpc4,"%d %d\n",s[expid-1][8],s[expid-1][2]);
	ins=s[expid-1][8];
	dlt=s[expid-1][9];
	upd=s[expid-1][10];
	
	data=(int **)malloc(sizeof(int *)*s[expid-1][0]);
	for(i=0;i<s[expid-1][0];i++)
	{
		data[i]=(int *)malloc(sizeof(int)*s[expid-1][2]);
	}
	if((fpc2=fopen(fnc2,"r"))==NULL)
	{
		printf("Cannot open file %s!\n",fnc2);
		return (0);
	}	
	
	fscanf(fpc2,"%s",temp);
	//j1=atoi(temp);
	fscanf(fpc2,"%s",temp);
	//j2=atoi(temp);
	
	for(i=0;i<s[expid-1][0];i++)
	{
		for(j=0;j<s[expid-1][2];j++)
		{
			fscanf(fpc2, "%s", temp);
			data[i][j]=atoi(temp);
		}
	}
	fclose(fpc2);
// generate upd 1	
// gecp(s[expid-1][8],s[expid-1][2],fpc4);
// generate upd 2
/*	
	printf("%ld,%ld\n",upd, s[expid-1][0]);
	
	for(i=0;i<upd;i++)
	{
		
		rd=rand()%s[expid-1][0];
		
		while(mark[rd]==1)
		{
			rd=rand()%s[expid-1][0];
		}
		mark[rd]=1;
	}
	printf("done\n");
	for(i=0;i<upd;i++)
	{
		if(mark[i]==1)
		{
			for(j=0;j<s[expid-1][2];j++)
			{
				fprintf(fpc4,"%d",data[i][j]);
				if (j!=s[expid-1][2]-1);
					fprintf(fpc4," ");
			}			
			fprintf(fpc4,"\n");
			
		}
	}
	
*/


//	fclose(fpc4);
	
	if(ins>0)
	{
		if((fpc5=fopen(fnc5,"w+"))==NULL)
		{
			printf("Cannot open file %s!\n",fnc5);
			return (0);
		}
		gecp(ins,s[expid-1][2],fpc5);
		fclose(fpc5);
	}
	else if(dlt>0)
	{
		if((fpc6=fopen(fnc6,"w+"))==NULL)
		{
			printf("Cannot open file %s!\n",fnc6);
			return (0);
		}	
		
		fprintf(fpc6,"%d %d\n",dlt,s[expid-1][2]);
		for(i=0;i<dlt;i++)
		{
			
			rd=rand()%s[expid-1][0];
			
			while(mark[rd]==1)
			{
				rd=rand()%s[expid-1][0];
			}
			mark[rd]=1;
		}
		printf("done\n");
		for(i=0;i<s[expid-1][0];i++)
		{
			if(mark[i]==1)
			{
				for(j=0;j<s[expid-1][2];j++)
				{
					fprintf(fpc6,"%d",data[i][j]);
					if (j!=s[expid-1][2]-1);
						fprintf(fpc6," ");
				}			
				fprintf(fpc6,"\n");
				
			}
		}	
		fclose(fpc6);
	}
	else if(upd>0)
	{
		if((fpc5=fopen(fnc5,"w+"))==NULL)
		{
			printf("Cannot open file %s!\n",fnc5);
			return (0);
		}
		gecp(upd/2,s[expid-1][2],fpc5);
		fclose(fpc5);
		if((fpc6=fopen(fnc6,"w+"))==NULL)
		{
			printf("Cannot open file %s!\n",fnc6);
			return (0);
		}	
		
		fprintf(fpc6,"%d %d\n",upd/2,s[expid-1][2]);
		for(i=0;i<upd/2;i++)
		{
			
			rd=rand()%s[expid-1][0];
			
			while(mark[rd]==1)
			{
				rd=rand()%s[expid-1][0];
			}
			mark[rd]=1;
		}
		printf("done\n");
		for(i=0;i<s[expid-1][0];i++)
		{
			if(mark[i]==1)
			{
				for(j=0;j<s[expid-1][2];j++)
				{
					fprintf(fpc6,"%d",data[i][j]);
					if (j!=s[expid-1][2]-1);
						fprintf(fpc6," ");
				}			
				fprintf(fpc6,"\n");
				
			}
		}	
		fclose(fpc6);
		
	}
	

	
}
